Panda3D

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | List of all members
PGMouseWatcherParameter Class Reference

This specialization on MouseWatcherParameter allows us to tag on additional elements to events for the gui system, and also inherits from TypedWritableReferenceCount so we can attach this thing to an event. More...

`#include "pgMouseWatcherParameter.h"`

Inheritance diagram for PGMouseWatcherParameter:

## Public Member Functions
| PGMouseWatcherParameter (const MouseWatcherParameter &copy)
virtual TypeHandle | force_init_type ()
virtual TypeHandle | get_type () const
void | operator= (const MouseWatcherParameter &copy)
void | output (std::ostream &out) const
Public Member Functions inherited from TypedWritableReferenceCount
| TypedWritableReferenceCount (const TypedWritableReferenceCount &copy)
virtual ReferenceCount * | as_reference_count ()
| Returns the pointer cast to a ReferenceCount pointer, if it is in fact of that type.
void | operator= (const TypedWritableReferenceCount &copy)
Public Member Functions inherited from TypedWritable
| TypedWritable (const TypedWritable &copy)
virtual int | complete_pointers (TypedWritable **p_list, BamReader *manager)
| Receives an array of pointers, one for each time manager->read_pointer() was called in fillin().
vector_uchar | encode_to_bam_stream () const
| Converts the TypedWritable object into a single stream of data using a BamWriter, and returns that data as a bytes object.
bool | encode_to_bam_stream (vector_uchar &data, BamWriter *writer=nullptr) const
| Converts the TypedWritable object into a single stream of data using a BamWriter, and stores that data in the indicated string.
virtual void | fillin (DatagramIterator &scan, BamReader *manager)
| This internal function is intended to be called by each class's make_from_bam() method to read in all of the relevant data from the BamFile for the new object.
virtual void | finalize (BamReader *manager)
| Called by the BamReader to perform any final actions needed for setting up the object after all objects have been read and all pointers have been completed.
UpdateSeq | get_bam_modified () const
| Returns the current bam_modified counter.
void | mark_bam_modified ()
| Increments the bam_modified counter, so that this object will be invalidated and retransmitted on any open bam streams.
void | operator= (const TypedWritable &copy)
virtual bool | require_fully_complete () const
| Some objects require all of their nested pointers to have been completed before the objects themselves can be completed.
virtual void | update_bam_nested (BamWriter *manager)
| Called by the BamWriter when this object has not itself been modified recently, but it should check its nested objects for updates.
virtual void | write_datagram (BamWriter *manager, Datagram &dg)
| Writes the contents of this object to the datagram for shipping out to a Bam file.
Public Member Functions inherited from TypedObject
| TypedObject (const TypedObject &copy)=default
TypedObject * | as_typed_object ()
| Returns the object, upcast (if necessary) to a TypedObject pointer.
const TypedObject * | as_typed_object () const
| Returns the object, upcast (if necessary) to a TypedObject pointer.
int | get_best_parent_from_Set (const std::set< int > &) const
int | get_type_index () const
| Returns the internal index number associated with this object's TypeHandle, a unique number for each different type.
bool | is_exact_type (TypeHandle handle) const
| Returns true if the current object is the indicated type exactly.
bool | is_of_type (TypeHandle handle) const
| Returns true if the current object is or derives from the indicated type.
TypedObject & | operator= (const TypedObject &copy)=default
Public Member Functions inherited from MemoryBase
void | operator delete (void *, void *)
void | operator delete (void *ptr)
void | operator delete[] (void *, void *)
void | operator delete[] (void *ptr)
void * | operator new (size_t size)
void * | operator new (size_t size, void *ptr)
void * | operator new[] (size_t size)
void * | operator new[] (size_t size, void *ptr)
Public Member Functions inherited from ReferenceCount
int | get_ref_count () const
WeakReferenceList * | get_weak_list () const
| Returns the WeakReferenceList associated with this ReferenceCount object.
bool | has_weak_list () const
| Returns true if this particular ReferenceCount object has a WeakReferenceList created, false otherwise.
void | local_object ()
| This function should be called, once, immediately after creating a new instance of some ReferenceCount-derived object on the stack.
void | ref () const
| Explicitly increments the reference count.
bool | ref_if_nonzero () const
| Atomically increases the reference count of this object if it is not zero.
bool | test_ref_count_integrity () const
| Does some easy checks to make sure that the reference count isn't completely bogus.
bool | test_ref_count_nonzero () const
| Does some easy checks to make sure that the reference count isn't zero, or completely bogus.
virtual bool | unref () const
| Explicitly decrements the reference count.
bool | unref_if_one () const
| Atomically decreases the reference count of this object if it is one.
WeakReferenceList * | weak_ref ()
| Adds the indicated PointerToVoid as a weak reference to this object.
void | weak_unref ()
| Removes the indicated PointerToVoid as a weak reference to this object.
Public Member Functions inherited from MouseWatcherParameter
| MouseWatcherParameter (const MouseWatcherParameter &other)
ButtonHandle | get_button () const
| Returns the mouse or keyboard button associated with this event.
const std::wstring & | get_candidate_string () const
| Returns the candidate string associated with this event.
std::string | get_candidate_string_encoded () const
| Returns the candidate string associated with this event.
std::string | get_candidate_string_encoded (TextEncoder::Encoding encoding) const
| Returns the candidate string associated with this event.
size_t | get_cursor_pos () const
| Returns the position of the user's edit cursor within the candidate string.
size_t | get_highlight_end () const
| Returns one more than the last highlighted character in the candidate string.
size_t | get_highlight_start () const
| Returns the first highlighted character in the candidate string.
int | get_keycode () const
| Returns the keycode associated with this event.
const ModifierButtons & | get_modifier_buttons () const
| Returns the set of modifier buttons that were being held down while the event was generated.
const LPoint2 & | get_mouse () const
| Returns the mouse position at the time the event was generated, in the normalized range (-1 .
bool | has_button () const
| Returns true if this parameter has an associated mouse or keyboard button, false otherwise.
bool | has_candidate () const
| Returns true if this parameter has an associated candidate string, false otherwise.
bool | has_keycode () const
| Returns true if this parameter has an associated keycode, false otherwise.
bool | has_mouse () const
| Returns true if this parameter has an associated mouse position, false otherwise.
bool | is_keyrepeat () const
| Returns true if the button-down even was generated due to keyrepeat, or false if it was an original button down.
bool | is_outside () const
| Returns true if the mouse was outside the region at the time the event was generated, false otherwise.
void | operator= (const MouseWatcherParameter &other)
void | output (std::ostream &out) const
void | set_button (const ButtonHandle &button)
| Sets the mouse or keyboard button that generated this event, if any.
void | set_candidate (const std::wstring &candidate_string, size_t highlight_start, size_t higlight_end, size_t cursor_pos)
| Sets the candidate string associated with this event, if any.
void | set_keycode (int keycode)
| Sets the keycode associated with this event, if any.
void | set_keyrepeat (bool flag)
| Sets the state of the "keyrepeat" flag.
void | set_modifier_buttons (const ModifierButtons &mods)
| Sets the modifier buttons that were being held while this event was generated.
void | set_mouse (const LPoint2 &mouse)
| Sets the mouse position that was current at the time the event was generated.
void | set_outside (bool flag)
| Sets the state of the "outside" flag.

## Static Public Member Functions
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedWritableReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
static | PT (TypedWritableReferenceCount) decode_from_bam_stream(vector_uchar data
Static Public Member Functions inherited from TypedWritable
static bool | decode_raw_from_bam_stream (TypedWritable *&ptr, ReferenceCount *&ref_ptr, vector_uchar data, BamReader *reader=nullptr)
| Reads the bytes created by a previous call to encode_to_bam_stream(), and extracts the single object on those bytes.
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedObject
static TypeHandle | get_class_type ()
static void | init_type ()
| This function is declared non-inline to work around a compiler bug in g++ 2.96.
Static Public Member Functions inherited from ReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()

## Additional Inherited Members
Public Types inherited from MouseWatcherParameter
enum | Flags { F_has_button = 0x001 , F_has_mouse = 0x002 , F_is_outside = 0x004 , F_has_keycode = 0x008 , F_has_candidate = 0x010 , F_is_keyrepeat = 0x020 }
Public Attributes inherited from TypedWritableReferenceCount
static BamReader * | reader = nullptr)
Public Attributes inherited from TypedObject
| get_type
Public Attributes inherited from ReferenceCount
| get_ref_count
| Returns the current reference count.
Public Attributes inherited from MouseWatcherParameter
ButtonHandle | _button
std::wstring | _candidate_string
size_t | _cursor_pos
int | _flags
size_t | _highlight_end
size_t | _highlight_start
int | _keycode
ModifierButtons | _mods
LPoint2 | _mouse
Static Public Attributes inherited from TypedWritable
static TypedWritable *const | Null = nullptr

## Detailed Description

This specialization on MouseWatcherParameter allows us to tag on additional elements to events for the gui system, and also inherits from TypedWritableReferenceCount so we can attach this thing to an event.

Definition at line 27 of file pgMouseWatcherParameter.h.

## Constructor & Destructor Documentation

## ◆ PGMouseWatcherParameter() [1/2]

PGMouseWatcherParameter::PGMouseWatcherParameter | ( |  | ) |
| inline

Definition at line 17 of file pgMouseWatcherParameter.I.

## ◆ PGMouseWatcherParameter() [2/2]

PGMouseWatcherParameter::PGMouseWatcherParameter | ( | const MouseWatcherParameter & | copy | ) |
| inline

Definition at line 24 of file pgMouseWatcherParameter.I.

## ◆ ~PGMouseWatcherParameter()

PGMouseWatcherParameter::~PGMouseWatcherParameter | ( |  | ) |
| virtual

Definition at line 21 of file pgMouseWatcherParameter.cxx.

## Member Function Documentation

## ◆ force_init_type()

virtual TypeHandle PGMouseWatcherParameter::force_init_type | ( |  | ) |
| inline virtual

Reimplemented from TypedWritableReferenceCount.

Definition at line 54 of file pgMouseWatcherParameter.h.

## ◆ get_class_type()

static TypeHandle PGMouseWatcherParameter::get_class_type | ( |  | ) |
| inline static

Definition at line 43 of file pgMouseWatcherParameter.h.

## ◆ get_type()

virtual TypeHandle PGMouseWatcherParameter::get_type | ( |  | ) | const
| inline virtual

Reimplemented from TypedWritableReferenceCount.

Definition at line 51 of file pgMouseWatcherParameter.h.

## ◆ init_type()

static void PGMouseWatcherParameter::init_type | ( |  | ) |
| inline static

Definition at line 46 of file pgMouseWatcherParameter.h.

## ◆ operator=()

void PGMouseWatcherParameter::operator= | ( | const MouseWatcherParameter & | copy | ) |
| inline

Definition at line 33 of file pgMouseWatcherParameter.I.

## ◆ output()

void PGMouseWatcherParameter::output | ( | std::ostream & | out | ) | const

Definition at line 28 of file pgMouseWatcherParameter.cxx.

The documentation for this class was generated from the following files:

- panda/src/pgui/pgMouseWatcherParameter.h
- panda/src/pgui/pgMouseWatcherParameter.cxx
- panda/src/pgui/pgMouseWatcherParameter.I